SdFat: SdExFat Class Reference

SdFat

Public Member Functions | List of all members
SdExFat Class Reference

SD file system class for exFAT volumes. More...

`#include <SdFat.h>`

Inheritance diagram for SdExFat:
[legend]
Collaboration diagram for SdExFat:
[legend]

## Public Member Functions
bool | begin (BlockDevice *dev, bool setCwv=true, uint8_t part=1)
bool | begin (SdCsPin_t csPin, uint32_t maxSck)
bool | begin (SdCsPin_t csPin=SS)
bool | begin (SdioConfig sdioConfig)
bool | begin (SdSpiConfig spiConfig)
uint32_t | bytesPerCluster () const
uint8_t | bytesPerClusterShift () const
uint16_t | bytesPerSector () const
uint8_t | bytesPerSectorShift () const
uint8_t * | cacheClear ()
SdCard * | card ()
bool | cardBegin (SdioConfig sdioConfig)
bool | cardBegin (SdSpiConfig spiConfig)
bool | chdir ()
bool | chdir (const char *path)
void | chvol ()
uint32_t | clusterCount () const
uint32_t | clusterHeapStartSector () const
void | errorHalt (print_t *pr)
void | errorHalt (print_t *pr, const __FlashStringHelper *msg)
void | errorHalt (print_t *pr, const char *msg)
void | errorPrint (Print *pr, const __FlashStringHelper *msg)
void | errorPrint (print_t *pr)
void | errorPrint (print_t *pr, char const *msg)
bool | exists (const char *path)
uint32_t | fatLength () const
uint32_t | fatStartSector () const
uint8_t | fatType () const
bool | format (print_t *pr=NULL)
uint32_t | freeClusterCount ()
bool | init (BlockDevice *dev, uint8_t part)
void | initErrorHalt (Print *pr, const __FlashStringHelper *msg)
void | initErrorHalt (print_t *pr)
void | initErrorHalt (print_t *pr, const char *msg)
void | initErrorPrint (Print *pr)
bool | isBusy ()
bool | ls (print_t *pr, const char *path, uint8_t flags)
bool | ls (print_t *pr, uint8_t flags=0)
bool | mkdir (const char *path, bool pFlag=true)
ExFile | open (const char *path, oflag_t oflag=0X00)
void | printFatType (print_t *pr)
void | printSdError (print_t *pr)
bool | remove (const char *path)
bool | rename (const char *oldPath, const char *newPath)
bool | rmdir (const char *path)
uint32_t | rootDirectoryCluster () const
uint32_t | rootLength ()
uint8_t | sdErrorCode ()
uint8_t | sdErrorData ()
uint32_t | sectorsPerCluster () const
uint8_t | sectorsPerClusterShift () const
bool | truncate (const char *path, uint64_t length)
ExFatVolume * | vol ()
bool | volumeBegin ()

## Detailed Description

SD file system class for exFAT volumes.

## Member Function Documentation

## ◆ begin() [1/5]

bool ExFatVolume::begin | ( | BlockDevice * | dev,
|  | bool | setCwv = `true`,
|  | uint8_t | part = `1`
| ) |  |
| inlineinherited

Initialize an FatVolume object.

Parameters

  [in] | dev | Device block driver.
  [in] | setCwv | Set current working volume if true.
  [in] | part | partition to initialize.

Returns
  true for success or false for failure.

## ◆ begin() [2/5]

bool SdBase< ExFatVolume >::begin | ( | SdCsPin_t | csPin,
|  | uint32_t | maxSck
| ) |  |
| inlineinherited

Initialize SD card and file system.

Parameters

  [in] | csPin | SD card chip select pin.
  [in] | maxSck | Maximum SCK frequency.

Returns
  true for success or false for failure.

## ◆ begin() [3/5]

bool SdBase< ExFatVolume >::begin | ( | SdCsPin_t | csPin = `SS` | ) |
| inlineinherited

Initialize SD card and file system.

Parameters

  [in] | csPin | SD card chip select pin.

Returns
  true for success or false for failure.

## ◆ begin() [4/5]

bool SdBase< ExFatVolume >::begin | ( | SdioConfig | sdioConfig | ) |
| inlineinherited

Initialize SD card and file system for SDIO mode.

Parameters

  [in] | sdioConfig | SDIO configuration.

Returns
  true for success or false for failure.

## ◆ begin() [5/5]

bool SdBase< ExFatVolume >::begin | ( | SdSpiConfig | spiConfig | ) |
| inlineinherited

Initialize SD card and file system for SPI mode.

Parameters

  [in] | spiConfig | SPI configuration.

Returns
  true for success or false for failure.

## ◆ bytesPerCluster()

uint32_t ExFatPartition::bytesPerCluster | ( |  | ) | const
| inlineinherited

Returns
  the number of bytes in a cluster.

## ◆ bytesPerClusterShift()

uint8_t ExFatPartition::bytesPerClusterShift | ( |  | ) | const
| inlineinherited

Returns
  the power of two for bytesPerCluster.

## ◆ bytesPerSector()

uint16_t ExFatPartition::bytesPerSector | ( |  | ) | const
| inlineinherited

Returns
  the number of bytes in a sector.

## ◆ bytesPerSectorShift()

uint8_t ExFatPartition::bytesPerSectorShift | ( |  | ) | const
| inlineinherited

Returns
  the power of two for bytesPerSector.

## ◆ cacheClear()

uint8_t* ExFatPartition::cacheClear | ( |  | ) |
| inlineinherited

Clear the cache and returns a pointer to the cache. Not for normal apps.

Returns
  A pointer to the cache buffer or zero if an error occurs.

## ◆ card()

SdCard* SdBase< ExFatVolume >::card
| inlineinherited

Returns
  Pointer to SD card object.

## ◆ cardBegin() [1/2]

bool SdBase< ExFatVolume >::cardBegin | ( | SdioConfig | sdioConfig | ) |
| inlineinherited

Initialize SD card in SDIO mode.

Parameters

  [in] | sdioConfig | SDIO configuration.

Returns
  true for success or false for failure.

## ◆ cardBegin() [2/2]

bool SdBase< ExFatVolume >::cardBegin | ( | SdSpiConfig | spiConfig | ) |
| inlineinherited

Initialize SD card in SPI mode.

Parameters

  [in] | spiConfig | SPI configuration.

Returns
  true for success or false for failure.

## ◆ chdir() [1/2]

bool ExFatVolume::chdir | ( |  | ) |
| inlineinherited

Set volume working directory to root.

Returns
  true for success or false for failure.

## ◆ chdir() [2/2]

bool ExFatVolume::chdir | ( | const char * | path | ) |
| inherited

Set volume working directory.

Parameters

  [in] | path | Path for volume working directory.

Returns
  true for success or false for failure.

## ◆ chvol()

void ExFatVolume::chvol | ( |  | ) |
| inlineinherited

Change global working volume to this volume.

## ◆ clusterCount()

uint32_t ExFatPartition::clusterCount | ( |  | ) | const
| inlineinherited

Returns
  the cluster count for the partition.

## ◆ clusterHeapStartSector()

uint32_t ExFatPartition::clusterHeapStartSector | ( |  | ) | const
| inlineinherited

Returns
  the cluster heap start sector.

## ◆ errorHalt() [1/3]

void SdBase< ExFatVolume >::errorHalt | ( | print_t * | pr | ) |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.

## ◆ errorHalt() [2/3]

void SdBase< ExFatVolume >::errorHalt | ( | print_t * | pr,
|  | const __FlashStringHelper * | msg
| ) |  |
| inlineinherited

Print msg and halt.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ errorHalt() [3/3]

void SdBase< ExFatVolume >::errorHalt | ( | print_t * | pr,
|  | const char * | msg
| ) |  |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ errorPrint() [1/3]

void SdBase< ExFatVolume >::errorPrint | ( | Print * | pr,
|  | const __FlashStringHelper * | msg
| ) |  |
| inlineinherited

Print msg, any SD error code.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ errorPrint() [2/3]

void SdBase< ExFatVolume >::errorPrint | ( | print_t * | pr | ) |
| inlineinherited

Print SD errorCode and errorData.

Parameters

  [in] | pr | Print destination.

## ◆ errorPrint() [3/3]

void SdBase< ExFatVolume >::errorPrint | ( | print_t * | pr,
|  | char const * | msg
| ) |  |
| inlineinherited

Print msg, any SD error code.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ exists()

bool ExFatVolume::exists | ( | const char * | path | ) |
| inlineinherited

Test for the existence of a file.

Parameters

  [in] | path | Path of the file to be tested for.

Returns
  true if the file exists else false.

## ◆ fatLength()

uint32_t ExFatPartition::fatLength | ( |  | ) | const
| inlineinherited

Returns
  the FAT length in sectors

## ◆ fatStartSector()

uint32_t ExFatPartition::fatStartSector | ( |  | ) | const
| inlineinherited

Returns
  the FAT start sector number.

## ◆ fatType()

uint8_t ExFatPartition::fatType | ( |  | ) | const
| inlineinherited

Returns
  Type FAT_TYPE_EXFAT for exFAT partition or zero for error.

## ◆ format()

bool SdExFat::format | ( | print_t * | pr = `NULL` | ) |
| inline

Format a SD card exFAT.

Parameters

  [in] | pr | Optional Print information.

Returns
  true for success or false for failure.

## ◆ freeClusterCount()

uint32_t ExFatPartition::freeClusterCount | ( |  | ) |
| inherited

Returns
  the free cluster count.

## ◆ init()

bool ExFatPartition::init | ( | BlockDevice * | dev,
|  | uint8_t | part
| ) |  |
| inherited

Initialize a exFAT partition.

Parameters

  [in] | dev | The blockDevice for the partition.
  [in] | part | The partition to be used. Legal values for part are 1-4 to use the corresponding partition on a device formatted with a MBR, Master Boot Record, or zero if the device is formatted as a super floppy with the FAT boot sector in sector zero.

Returns
  true for success or false for failure.

## ◆ initErrorHalt() [1/3]

void SdBase< ExFatVolume >::initErrorHalt | ( | Print * | pr,
|  | const __FlashStringHelper * | msg
| ) |  |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ initErrorHalt() [2/3]

void SdBase< ExFatVolume >::initErrorHalt | ( | print_t * | pr | ) |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.

## ◆ initErrorHalt() [3/3]

void SdBase< ExFatVolume >::initErrorHalt | ( | print_t * | pr,
|  | const char * | msg
| ) |  |
| inlineinherited

Print error info and halt.

Parameters

  [in] | pr | Print destination.
  [in] | msg | Message to print.

## ◆ initErrorPrint()

void SdBase< ExFatVolume >::initErrorPrint | ( | Print * | pr | ) |
| inlineinherited

Print error details after begin() fails.

Parameters

  [in] | pr | Print destination.

## ◆ isBusy()

bool ExFatPartition::isBusy | ( |  | ) |
| inlineinherited

Check for BlockDevice busy.

Returns
  true if busy else false.

## ◆ ls() [1/2]

bool ExFatVolume::ls | ( | print_t * | pr,
|  | const char * | path,
|  | uint8_t | flags
| ) |  |
| inlineinherited

List the contents of a directory.

Parameters

  [in] | pr | Print stream for list.
  [in] | path | directory to list.
  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Returns
  true for success or false for failure.

## ◆ ls() [2/2]

bool ExFatVolume::ls | ( | print_t * | pr,
|  | uint8_t | flags = `0`
| ) |  |
| inlineinherited

List the directory contents of the root directory.

Parameters

  [in] | pr | Print stream for list.
  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Returns
  true for success or false for failure.

## ◆ mkdir()

bool ExFatVolume::mkdir | ( | const char * | path,
|  | bool | pFlag = `true`
| ) |  |
| inlineinherited

Make a subdirectory in the volume root directory.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for the subdirectory.
  [in] | pFlag | Create missing parent directories if true.

Returns
  true for success or false for failure.

## ◆ open()

ExFile ExFatVolume::open | ( | const char * | path,
|  | oflag_t | oflag = `0X00`
| ) |  |
| inlineinherited

open a file

Parameters

  [in] | path | location of file to be opened.
  [in] | oflag | open flags.

Returns
  a ExFile object.

## ◆ printFatType()

void SdBase< ExFatVolume >::printFatType | ( | print_t * | pr | ) |
| inlineinherited

Print volume FAT/exFAT type.

Parameters

  [in] | pr | Print destination.

## ◆ printSdError()

void SdBase< ExFatVolume >::printSdError | ( | print_t * | pr | ) |
| inlineinherited

Print error info and return.

Parameters

  [in] | pr | Print destination.

## ◆ remove()

bool ExFatVolume::remove | ( | const char * | path | ) |
| inlineinherited

Remove a file from the volume root directory.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for the file.

Returns
  true for success or false for failure.

## ◆ rename()

bool ExFatVolume::rename | ( | const char * | oldPath,
|  | const char * | newPath
| ) |  |
| inlineinherited

Rename a file or subdirectory.

Parameters

  [in] | oldPath | Path name to the file or subdirectory to be renamed.
  [in] | newPath | New path name of the file or subdirectory.

The newPath object must not exist before the rename call.

The file to be renamed must not be open. The directory entry may be moved and file system corruption could occur if the file is accessed by a file object that was opened before the rename() call.

Returns
  true for success or false for failure.

## ◆ rmdir()

bool ExFatVolume::rmdir | ( | const char * | path | ) |
| inlineinherited

Remove a subdirectory from the volume's working directory.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for the subdirectory.

The subdirectory file will be removed only if it is empty.

Returns
  true for success or false for failure.

## ◆ rootDirectoryCluster()

uint32_t ExFatPartition::rootDirectoryCluster | ( |  | ) | const
| inlineinherited

Returns
  the root directory start cluster number.

## ◆ rootLength()

uint32_t ExFatPartition::rootLength | ( |  | ) |
| inherited

Returns
  the root directory length.

## ◆ sdErrorCode()

uint8_t SdBase< ExFatVolume >::sdErrorCode
| inlineinherited

Returns
  SD card error code.

## ◆ sdErrorData()

uint8_t SdBase< ExFatVolume >::sdErrorData
| inlineinherited

Returns
  SD card error data.

## ◆ sectorsPerCluster()

uint32_t ExFatPartition::sectorsPerCluster | ( |  | ) | const
| inlineinherited

Returns
  the number of sectors in a cluster.

## ◆ sectorsPerClusterShift()

uint8_t ExFatPartition::sectorsPerClusterShift | ( |  | ) | const
| inlineinherited

Returns
  the power of two for sectors per cluster.

## ◆ truncate()

bool ExFatVolume::truncate | ( | const char * | path,
|  | uint64_t | length
| ) |  |
| inlineinherited

Truncate a file to a specified length. The current file position will be at the new EOF.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for the file.
  [in] | length | The desired length for the file.

Returns
  true for success or false for failure.

## ◆ vol()

ExFatVolume * SdBase< ExFatVolume >::vol
| inlineinherited

Returns
  pointer to base volume

## ◆ volumeBegin()

bool SdBase< ExFatVolume >::volumeBegin
| inlineinherited

Initialize file system after call to cardBegin.

Returns
  true for success or false for failure.

The documentation for this class was generated from the following file:

- ArduinoSdFat/libraries/SdFat/src/SdFat.h